local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Health1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/Health1.fbx/Prefab/ConstructionPole", "PREFAB_PLAGUE_HOSPITAL_POLE")
mod:registerAssetId("models/Health1.fbx/Prefab/HospitalPart", "PREFAB_PLAGUE_HOSPITAL")
mod:registerAssetId("models/Health1.fbx/Prefab/HospitalConstructionSteps", "PREFAB_PLAGUE_HOSPITAL_CONSTR")
mod:registerAssetId("models/Health1.fbx/Prefab/WardPart", "PREFAB_PLAGUE_HOSPITAL_BEDS")
mod:registerAssetId("models/Health1.fbx/Prefab/WardConstructionSteps", "PREFAB_PLAGUE_HOSPITAL_BEDS_CONSTR")
mod:registerAssetId("models/Health1.fbx/Prefab/DoorPart", "PREFAB_PLAGUE_HOSPITAL_DOOR")
mod:registerAssetId("models/Health1.fbx/Prefab/WindowPart", "PREFAB_PLAGUE_HOSPITAL_WINDOW")



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Health1.fbx/Prefab/HospitalPart", { "PLATFORM" })



-- Grounding  -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Health1.fbx/Prefab/DoorPart", { DataType = "COMP_GROUNDED" })



-- Smoke Emitter -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Health1.fbx/Prefab/HospitalPart/SmokeEmitter.001", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = true
})

mod:registerPrefabComponent("models/Health1.fbx/Prefab/HospitalPart/SmokeEmitter.001", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})



-- Building part Type  -------------------------------------------------------------------------------------
mod:registerEnumValue ("BUILDING_PART_TYPE", "HOSPITAL_BEDS")
-- mod:registerPrefabComponent("models/Health1.fbx/Prefab/BedsPart", { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })
mod:registerPrefabComponent("models/Health1.fbx/Prefab/DoorPart", { DataType = "COMP_BUILDING_PART", BuildingPartType = "DOOR" })
mod:registerPrefabComponent("models/Health1.fbx/Prefab/WindowPart", { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })



-- Resource: Health ------------------------------------------------------------------------
mod:registerAssetId("icons/Health.png", "ICON_HEALTH")
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_HEALTH" )

mod:register({
    DataType = "RESOURCE",
    Id = "RESOURCE_HEALTH",
    ResourceName = "RESOURCE_HEALTH_NAME",
    Icon = "ICON_HEALTH",
    ResourceTypeList = {
        "RESOURCE_TYPE_HEALTH",
    },
    IsTradable = false,
    DisplayInInventory = false,
    DisplayInToolbar = false,
})



-- -- Resource Container: Health -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent( "models/Health1.fbx/Prefab/HospitalPart/HEALTHCONTAINER", {
--     DataType = "COMP_RESOURCE_CONTAINER",
--     ResourceData = "RESOURCE_HEALTH",
--     IsReplenishable = false,
--     ResourceValue = 1.0, -- how many are gathered with each pick
--     AvailableQuantity = 100, -- maximum container stock?
--     Radius = 1, -- distance from container that the villager will stand to pick
--     IsDestroyWhenEmpty = false
-- })

-- -- Plantable -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/Health1.fbx/Prefab/BedsPart/Beds.001", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })

-- -- Building Part
-- mod:registerPrefabComponent("models/Health1.fbx/Prefab/BedsPart/Beds.001", { DataType = "COMP_BUILDING_PART" })



-- -- Custom Component: Hospital -------------------------------------------------------------------------------------
-- local COMP_PLAGUE_HOSPITAL = {
-- 	TypeName = "COMP_PLAGUE_HOSPITAL",
-- 	ParentType = "COMPONENT",
-- 	Properties = {
--         { Name = "HealingCount", Type = "integer", Default = 0, Flags = { "SAVE_GAME" } },
--     }
-- }



-- -- Custom Component: Hospital workplace: Initialise -------------------------------------------------------------------------------------
-- function COMP_PLAGUE_HOSPITAL:init()

--     local compwork = self:getOwner():getOrCreateComponent("COMP_WORKPLACE")
--     mod:log(tostring(compwork))

--     event.register(self, compwork.ON_WORKPLACE_PAUSED, function(pas)
--         mod:log("Workplace paused: " .. tostring(pas))
--     end)

-- end



-- -- Custom Component: Hospital: Register -------------------------------------------------------------------------------------
-- mod:registerClass(COMP_PLAGUE_HOSPITAL)



-- -- Attach component to the Hospital
-- mod:registerPrefabComponent("PREFAB_PLAGUE_HOSPITAL", { DataType = "COMP_PLAGUE_HOSPITAL" } )



-- Building: Hospital -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_PLAGUE_HOSPITAL",
	Name = "BUILDING_PLAGUE_HOSPITAL_NAME",
	Description = "BUILDING_PLAGUE_HOSPITAL_DESC",
    BuildingType = "GENERAL",
    AssetCoreBuildingPart = "BUILDING_PART_PLAGUE_HOSPITAL_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_PART_SET_PLAGUE_1",
			BuildingPartList = { 
                "BUILDING_PART_PLAGUE_HOSPITAL",
            }
		},
		{
			Name = "BUILDING_PART_SET_PLAGUE_2",
			BuildingPartList = { 
				"BUILDING_PART_PLAGUE_HOSPITAL_BEDS",
                "BUILDING_PART_PLAGUE_HOSPITAL_DOOR",
                "BUILDING_PART_PLAGUE_HOSPITAL_WINDOW",
			}
		},
	},	
	RequiredPartList = {
		{ Category = "CORE", Min = 1, Max = 1 },
		{ Category = "DOOR", Min = 1, Max = 1 },
		{ Category = "HOSPITAL_BEDS", Min = 1, Max = 1 },
    },
    VillagerRequired = {
        Status = "NEWCOMER",
        Quantity = 50
    },
	IsEditable = true	
})



-- Building Part: Construction pole -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PLAGUE_HOSPITAL_POLE",
	Name = "BUILDING_PART_PLAGUE_HOSPITAL_NAME",
	Description = "BUILDING_PLAGUE_HOSPITAL_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PLAGUE_HOSPITAL_POLE"
    },
    IsVisibleWhenBuilt = false
})



-- Building Part: Hospital building -------------------------------------------------------------------------------------
local poly1 = { -- y, x     Facing from the top in Blender: y increases going down, x increases going right

    { -3.0, -7.0 },
    { -4.0, -5.25 },
    { -4.75, -3.25 },
    { -4.75, 3.5 },
    { -3.5, 5.25 },
    { 3.75, 5.25 },
    { 4.5, 3.0 },
    { 5.0, 1.25 },
    { 6.0, -2.25 },
    { 5.25, -4.0 },
    { 5.25, -7.0 },

}


local poly2 = {

    { 5, -5 },
    { -5, -5 },
    { -5, 5 },
    { 5, 5 },
    { 5, -3 },

    { 4, -3 },
    { 4, 4},
    { -4, 4 },
    { -4, -4 },
    { 5, -5 },

}

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PLAGUE_HOSPITAL",
	Name = "BUILDING_PART_PLAGUE_HOSPITAL_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PLAGUE_HOSPITAL"
    },
    ConstructionVisual = "PREFAB_PLAGUE_HOSPITAL_CONSTR",
    Category = "CORE",
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = poly1,
				Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
		}
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_PLAGUE_HOSPITAL",
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 60 }
        },
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 40 }
        },
        RessourcesNeeded = {
            { Resource = "STONE", Quantity = 20 },
            { Resource = "WOOD", Quantity = 12 },
            { Resource = "PLANK", Quantity = 20 },
            { Resource = "POLISHED_STONE", Quantity = 10 },
            { Resource = "TOOL", Quantity = 4 },
		}
	}
})



-- Building Part: Hospital Beds -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PLAGUE_HOSPITAL_BEDS",
	Name = "BUILDING_PART_PLAGUE_HOSPITAL_BEDS_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PLAGUE_HOSPITAL_BEDS"
    },
    ConstructionVisual = "PREFAB_PLAGUE_HOSPITAL_BEDS_CONSTR",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {8.0, 6.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
    },
    Category = "HOSPITAL_BEDS",
    AssetBuildingFunction = "BUILDING_FUNCTION_PLAGUE_HOSPITAL_BEDS",
    Cost = {
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 10 }
        },
        RessourcesNeeded = {
            { Resource = "STONE", Quantity = 12 },
            { Resource = "WOOD", Quantity = 12 },
		}
	}
})




-- Building Part: Hospital door -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PLAGUE_HOSPITAL_DOOR",
	Name = "BUILDING_PART_PLAGUE_HOSPITAL_DOOR_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PLAGUE_HOSPITAL_DOOR"
    },
    Category = "DOOR",
    Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Building Part: Hospital window -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PLAGUE_HOSPITAL_WINDOW",
	Name = "BUILDING_PART_PLAGUE_HOSPITAL_WINDOW_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PLAGUE_HOSPITAL_WINDOW"
    },
    Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Job: Physician -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_PHYSICIAN",
	JobName = "JOB_PHYSICIAN_NAME",
	JobDescription = "JOB_PHYSICIAN_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
    ProductionDelay = 60.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		-- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
		-- 	Model = "PREFAB_TOOL_SHEPHERD_STICK"
		-- },
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_PHYSICIAN"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_PHYSICIAN"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_PHYSICIAN"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_PHYSICIAN"
    }
})



-- Building Function: Physician -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_PLAGUE_HOSPITAL",
    Name = "BUILDING_FUNCTION_PLAGUE_HOSPITAL_NAME",
    WorkerCapacity = 4,
    RelatedJob = { 
        Job = "JOB_PHYSICIAN", 
        Behavior = "BEHAVIOR_GATHER"
    },
    InputInventoryCapacity = {
        { Resource = "RESOURCE_HEALTH", Quantity = 1 },
	},
    ResourceListNeeded = {
        { Resource = "RESOURCE_HEALTH", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_HEALTH", Quantity = 0 },
    }
})



-- Building Function: Hospital Beds -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_PLAGUE_HOSPITAL_BEDS",
    Name = "BUILDING_FUNCTION_PLAGUE_HOSPITAL_BEDS_NAME",
    WorkerCapacity = 10,
    RelatedJob = { 
        Job = "JOB_UNWELL", 
        Behavior = "BEHAVIOR_WORK"
    },
    IsPrivate = true,
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
    }
})


